package com.agilefaqs.rft.domain;

public class Country {

    private String name;
    private String continent;
    private String code;
    private String moniker;

    public Country() {
    }

    public Country(final String code, final String name) {
        this.code = code;
        this.name = name;
    }

    public Country(final String code, final String name, final String moniker) {
        this.code = code;
        this.name = name;
        this.moniker = moniker;
    }

    public String getName() {
        return name;
    }

    public void setName(final String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(final String code) {
        this.code = code;
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) {
            return true;
        }
        if (!o.getClass().equals(this.getClass())) {
            return false;
        }

        Country country = (Country) o;

        if (code != null && code.equals(country.getCode()) || name != null && name.equals(country.getName())) {
            return true;
        }

        return false;
    }

    @Override
    public int hashCode() {
        int result;
        result = name != null ? name.hashCode() : 0;
        result = 31 * result + (code != null ? code.hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return name;
    }

    public String getContinent() {
        return continent;
    }

    public void setContinent(final String continent) {
        this.continent = continent;
    }

    /**
     * @return the moniker
     */
    public String getMoniker() {
        return moniker;
    }
}
