/**
 * 
 */
package com.agilefaqs.rft.suggestions;

import java.util.List;

import com.agilefaqs.rft.suggestions.strategies.ChildStrategyParam;
import com.agilefaqs.rft.suggestions.strategies.ChildSuggestionFactory;
import com.agilefaqs.rft.suggestions.strategies.ChildSuggestionStrategy;

public class IdentitySuggestionOneStrategy implements SuggestionStrategy {
    private final List<ChildSuggestionStrategy> childStrategies;

    public IdentitySuggestionOneStrategy(final ChildSuggestionFactory childSuggestionFactory) {
        childStrategies = childSuggestionFactory.getChildStrategiesForSuggestionOne();
    }

    @Override
    public String getIdentity(final SuggestionParam params) {
        ChildStrategyParam childParam = new ChildStrategyParam(params.getValidFirstNameToken(), params.getValidLastNameToken(), null);
        for (ChildSuggestionStrategy childStrategy : childStrategies) {
            final String Identity = childStrategy.generateId(childParam);
            if (Identity != null) {
                return Identity;
            }
        }
        return null;
    }
}
