package com.agilefaqs.rft.suggestions;

import static org.easymock.EasyMock.expect;
import static org.easymock.classextension.EasyMock.createMock;
import static org.easymock.classextension.EasyMock.replay;
import static org.easymock.classextension.EasyMock.verify;
import static org.junit.Assert.assertEquals;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.junit.Test;

import com.agilefaqs.rft.suggestions.SuggestionStrategy;
import com.agilefaqs.rft.suggestions.SuggestionStrategyFactory;
import com.agilefaqs.rft.suggestions.strategies.ChildSuggestionFactory;
import com.agilefaqs.rft.suggestions.strategies.ChildSuggestionStrategy;

public class SuggestionStrategyFactoryTest {
    private final ChildSuggestionFactory childSuggestionFactory = createMock(ChildSuggestionFactory.class);

    @Test
    public void shouldGetAllTheStrategies() throws Exception {
        expect(childSuggestionFactory.getStrategies()).andReturn(new ArrayList<ChildSuggestionStrategy>()).times(3);
        expect(childSuggestionFactory.getChildStrategiesForSuggestionOne()).andReturn(new LinkedList<ChildSuggestionStrategy>());
        replay(childSuggestionFactory);
        SuggestionStrategyFactory factory = new SuggestionStrategyFactory(childSuggestionFactory);
        final List<SuggestionStrategy> strategies = factory.getStrategies();
        assertEquals("expected was 4 but was : " + strategies.size(), 4, strategies.size());
        verify(childSuggestionFactory);
    }
}
